# Method: digest

This call takes a Data Encryption Key (DEK) wrapped with the wrap API, and
returns the base64 encoded
[resource key hash](https://developers.google.com/workspace/cse/reference/resource-key-hash).

See also: [`rewrap`](https://developers.google.com/workspace/cse/reference/rewrap)

### HTTP request

`POST https://KACLS_URL/digest`

Replace `KACLS_URL` with the Key Access Control List
Service (KACLS) URL.

### Path parameters

None.

### Request body

The request body contains data with the following structure:

| JSON representation ||
|---|---|
| ``` { "authorization": string, "reason": string, "wrapped_key": string } ``` |

| Fields ||
|---|---|
| `authorization` | `string` A JWT asserting that the user is allowed to unwrap a key for `resource_name`. See [authorization tokens](https://developers.google.com/workspace/cse/reference/authorization-tokens). |
| `reason` | `string (UTF-8)` A passthrough JSON string providing additional context about the operation. The JSON provided should be sanitized before being displayed. Max size: 1 KB. |
| `wrapped_key` | `string` The base64 binary object returned by [`wrap`](https://developers.google.com/workspace/cse/reference/wrap). |

### Response body

If successful, this method returns a base64 encoded
[resource key hash](https://developers.google.com/workspace/cse/reference/resource-key-hash).

If the operation fails, a
[structured error reply](https://developers.google.com/workspace/cse/reference/structured-errors)
should be returned.

| JSON representation ||
|---|---|
| ``` { "resource_key_hash": string } ``` |

| Fields ||
|---|---|
| `resource_key_hash` | `string` base64 encoded binary object. See [resource key hash](https://developers.google.com/workspace/cse/reference/resource-key-hash). |

### Example

#### Request

    POST https://mykacls.example.com/v1/digest

    {
       "wrapped_key": "7qTh6Mp+svVwYPlnZMyuj8WHTrM59wl/UI50jo61Qt/QubZ9tfsUc1sD62xdg3zgxC9quV4r+y7AkbfIDhbmxGqP64pWbZgFzOkP0JcSn+1xm/CB2E5IknKsAbwbYREGpiHM3nzZu+eLnvlfbzvTnJuJwBpLoPYQcnPvcgm+5gU1j1BjUaNKS/uDn7VbVm7hjbKA3wkniORC2TU2MiHElutnfrEVZ8wQfrCEpuWkOXs98H8QxUK4pBM2ea1xxGj7vREAZZg1x/Ci/E77gHxymnZ/ekhUIih6Pwu75jf+dvKcMnpmdLpwAVlE1G4dNginhFVyV/199llf9jmHasQQuaMFzQ9UMWGjA1Hg2KsaD9e3EL74A5fLkKc2EEmBD5v/aP+1RRZ3ISbTOXvxqYIFCdSFSCfPbUhkc9I2nHS0obEH7Q7KiuagoDqV0cTNXWfCGJ1DtIlGQ9IA6mPDAjX8Lg==",
       "authorization": "eyJhbGciOi...",
       "reason": "{client:'drive' op:'read'}"
    }

#### Response

    {
       "resource_key_hash": "qClT153ghqBOLPpdMsc4S4n6okPrRaLPBYT0zRcn+go="
    }